//      OLED C Click older version v1.00 board - now obsolete
//      OLED C click uses a 3.3V power supply.
//      MCU:             PIC18F45K22
//      Dev. Board:      EasyPIC v7
//      Oscillator:      HS-PLL, 8MHz Crystal, 32MHz MCU Clock
//     - Place OLED C Click board in the mikroBUS socket 1.
// amateur buggy code - author accepts no responsibility for anything, ever
// 12 October 2018
// font is copyright mikroElektronica and copied from new version board demo code
// some other portions of code may be copied from mikroElektronika demo code, so copyright may apply
// x,y cordinates are adjusted for 0,0 top left of OLED screen

// font options are 1 2 3 4     (6 7 8 10 14 16 18 if uncommented)    - any other numbers will not display

// remove or comment out font code from function OLED_Out function to save ROM space, as fonts use a lot of memory

// still to do:
//
// Fix % character in font 4

#include "stdint.h"
#include "Oled_C.h"
#include "fonts.h"                                                              // remember to rebuild all if you change any included files

sbit OLED_RST at LATE1_bit;               // display RSTB
sbit OLED_CS at LATE0_bit;                // display CSB
sbit OLED_DC at LATC0_bit;                // D/C display A0
sbit OLED_T at LATA2_bit;                 // R/W display D3        0=write, 1=read

// RGB 565 colours     -  bits 15-0 are r4 r3 r2 r1 r0 g5 g4 g3 g2 g1 g0 b4 b3 b2 b1 b0
#define Color_Black           0x0000      /*   0,   0,   0 */
#define Color_Navy            0x000F      /*   0,   0, 128 */
#define Color_DarkGreen       0x03E0      /*   0, 128,   0 */
#define Color_DarkCyan        0x03EF      /*   0, 128, 128 */
#define Color_Maroon          0x7800      /* 128,   0,   0 */
#define Color_Purple          0x780F      /* 128,   0, 128 */
#define Color_Olive           0x7BE0      /* 128, 128,   0 */
#define Color_LightGrey       0xC618      /* 192, 192, 192 */
#define Color_DarkGrey        0x7BEF      /* 128, 128, 128 */
#define Color_Blue            0x001F      /*   0,   0, 255 */
#define Color_Green           0x07E0      /*   0, 255,   0 */
#define Color_Cyan            0x07FF      /*   0, 255, 255 */
#define Color_Red             0xF800      /* 255,   0,   0 */
#define Color_Magenta         0xF81F      /* 255,   0, 255 */
#define Color_Mustard         0xff00
#define Color_Yellow          0xFFE0      /* 255, 255,   0 */
#define Color_White           0xFFFF      /* 255, 255, 255 */
#define Color_Orange          0xFD20      /* 255, 165,   0 */
#define Color_GreenYellow     0xAFE5      /* 173, 255,  47 */
#define Color_Pink            0xFB1B

// prototypes
void OLED_CLS();                                                                // write black to the whole screen
void OLED_Out(char x_pos, char y_pos, char *text);                              // output text to OLED using current font and colour
void DrawPixel(char px, char py, uint16_t color);                               // draw a single pixel of any colour - 0,0 is top left
void DrawLineH(char px1, char px2, char py, uint16_t color);                    // draw a horizontal line - 0,0 is top left
void DrawLineV(char px, char py1, char py2, uint16_t color);                    // draw a vertical line - 0,0 is top left
void DrawBox(char px1, char px2, char py1, char py2, uint16_t color);           // draw a box - 0,0 is top left
void InitMCU();                                                                 // various initialision routines
void OLED_C_command(unsigned char reg_index, unsigned char reg_value);          // send a SPI command to display
void OLED_C_MemorySize(char X1, char X2, char Y1, char Y2);                     // set area of interest on display
void DDRAM_access();                                                            // switch display to data mode
void OLED_C_Color(char colorMSB, char colorLSB );                               // write colour value to display current position
void OLED_C_Out(unsigned char x_co_ord, unsigned char y_co_ord, unsigned char ascii_in, uint16_t color, unsigned char OLED_font);  // write a single ascii character to display - bodged
void test1();
void test2();
void test3();

// global variables
unsigned char display_font;                                                     // valid values are 1 2 3 4     (6 7 8 10 14 16 18 if uncommented)
unsigned int display_color;                                                     // bits 15-0 are r4 r3 r2 r1 r0 g5 g4 g3 g2 g1 g0 b4 b3 b2 b1 b0
unsigned char display_x;                                                        // current x coordinate for OLED color click v100 - 0,0 is top left
unsigned char display_y;                                                        // current y coordinate for OLED color click v100 - 0,0 is top left
unsigned char last_width;                                                       // width of most recent character
unsigned char font_nrows;                                                       // number of rows in most recent font
unsigned char new_y;                                                            // next line calculated by font

// the action starts here
void main(){

    InitMCU();                                                                  // initialise processor and OLED click - set defaults

    test1();                                                                    // check fonts 1 to 4
    //test2();                                                                    // check fonts 6 to 18 - requires uncommenting in OLED_Out function
    test3();                                                                    // more checks of functions
    
    while(1);       // handy debug loop                                         // not stricly neccassry for mikroE compilers, but vital for other compilers
}

// simple test routine - delete to save ROM
void test3(){
char j;

    OLED_CLS();                                                                 // clear screen
    display_color = Color_White;
    display_font = 2;
    OLED_Out(2, new_y, "Font 2");                                               // output text to OLED using current font and colour
    display_color = Color_Magenta;
    OLED_Out(display_x, display_y, " ABC");                                     // continue text
    display_color = Color_Cyan;
    OLED_Out(display_x, display_y, "def");                                      // continue text
    display_color = Color_Red;
    OLED_Out(display_x, display_y, "ghi");                                      // continue text
    display_color = Color_Mustard;
    display_font = 3;
    OLED_Out(0, new_y-2, "  Font 3 ABC %");                                     // next line minus 2 to squash up a bit
    display_color = Color_Yellow;
    display_font = 4;
    OLED_Out(12, new_y-2, "Font 4");                                            // next line
    display_font = 1;
    OLED_Out(18, new_y, "Font 1");                                              // next line

    for(j=0 ; j<96 ; j++){
        DrawPixel(j,j,Color_White);
        DrawPixel(95-j,j,Color_White);
    }
    
    DrawBox(4,90,38,67,Color_Green);
    DrawBox(5,89,39,66,Color_Green);
    DrawLineH(0,95,0,Color_Red);
    DrawLineV(0,0,95,Color_Red);
    DrawLineH(0,95,95,Color_Red);
    DrawLineV(95,0,95,Color_Red);
    Delay_ms(3000);
}

// simple test routine - delete to save ROM
void test2(){
    OLED_CLS();                                                                 // clear screen
    display_color = Color_Cyan;
    display_font = 6;
    OLED_Out(0, new_y, "Font 6 ABCdef123 %");                                   // next line
    display_font = 7;
    OLED_Out(0, new_y, "Font 7 ABCdef123 %");                                   // next line
    display_font = 8;
    OLED_Out(0, new_y, "Font 8 ABCdef %");                                      // next line
    display_font = 10;
    OLED_Out(0, new_y, "Font 10 ABC %");                                        // next line
    display_font = 14;
    OLED_Out(0, new_y, "Font 14 %");                                            // next line
    display_font = 18;
    OLED_Out(0, new_y, "F 18 %");                                               // next line
    Delay_ms(3000);
}

// simple test routine - delete to save ROM
void test1(){
    OLED_CLS();                                                                 // clear screen
    display_color = Color_Cyan;
    display_font = 1;
    OLED_Out(0, new_y, "Font 1 %");                                             // next line
    display_font = 2;
    OLED_Out(0, new_y, "Font 2 ABCdef %");                                      // next line
    display_font = 3;
    OLED_Out(0, new_y, "Font 3 ABC %");                                         // next line
    display_font = 4;
    OLED_Out(0, new_y, "F 4 %");                                                // next line  - always test % as it is the widest character
    Delay_ms(3000);
}

// write black to the whole screen
void OLED_CLS(){
int j;

    OLED_C_command(0x1D,0x02);                                                  // Set Memory Read/Write mode
    OLED_C_MemorySize(0x00,0x5F,0x00,0x5F);                                     // whole screen
    DDRAM_access();
    for(j = 0 ; j < 9216 ; j++){                                                // black box   96x96=9216
        OLED_C_Color(0x00,0x00);                                                // black
    }
    display_x = 0;
    display_y = 0;
    new_y = 0;
}

void DrawLineH(char px1, char px2, char py, uint16_t color){                    // draw a horizontal line - 0,0 is top left
char index;

    for(index = px1 ; index <= px2 ; index++){
        DrawPixel(index, py, color);
    }
}
void DrawLineV(char px, char py1, char py2, uint16_t color){                    // draw a vertical line - 0,0 is top left
char index;

    for(index = py1 ; index <= py2; index++){
        DrawPixel(px, index, color);
    }
}
void DrawBox(char px1, char px2, char py1, char py2, uint16_t color){           // draw a box - 0,0 is top left
char index;

    for(index = px1 ; index <= px2; index++){
        DrawPixel(index, py1, color);
    }
    for(index = px1 ; index <= px2; index++){
        DrawPixel(index, py2, color);
    }
    for(index = py1 ; index <= py2; index++){
        DrawPixel(px1, index, color);
    }
    for(index = py1 ; index <= py2; index++){
        DrawPixel(px2, index, color);
    }
}

// output null terminated text to OLED using current font and colour
void OLED_Out(char x_pos, char y_pos, char *text){                              // output text to OLED using current font and colour
char ochar;
unsigned int opoint = 0;

    display_x = x_pos;
    display_y = y_pos;
    do{
        ochar = text[opoint];                                                   // get next chc in string
        if(ochar){                                                              // do not process null terminator
            OLED_C_Out(display_x,display_y,ochar,display_color,display_font);
            opoint++;                                                           // go for next chc
        }
    }while(ochar);                                                              // loop until null terminator found
    new_y = display_y + font_nrows;
}

//Send command to OLED C display
void OLED_C_command(unsigned char reg_index, unsigned char reg_value){
//Select index addr
    OLED_CS = 0;
    OLED_DC = 0;                          // 0=command
    SPI1_Write(reg_index);
    OLED_CS = 1;
//Write data to reg
    OLED_CS = 0;
    OLED_DC = 1;                          // 1=data or parameter
    SPI1_Write(reg_value);
    OLED_CS = 1;
}

//Send data to OLED C display
void OLED_C_data(unsigned char data_value){
    OLED_CS = 0;
    OLED_DC = 1;                          // 1=data or parameter
    SPI1_Write(data_value);
    OLED_CS = 1;
}

// Init MCU function
void InitMCU(){

    TRISE1_bit = 0;                         // click rst
    TRISE0_bit = 0;                         // click cs
    TRISC0_bit = 0;                         // click D/C
    TRISA2_bit = 0;                         // click T (R/W)
    // Initialize SPI module - use slower SPI clock than library default, which is too fast to be reliable
    SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV64, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);         // RC3=SCK, RC4=MISO, RC5 =MOSI
    OLED_T=0;                               // click R/W=0, write

// Init sequence for 96x96 OLED color module
    OLED_RST = 0;
    Delay_ms(10);
    OLED_RST = 1;
    Delay_ms(10);
    /*  Soft reset */
    OLED_C_command(SEPS114A_SOFT_RESET,0x00);                                   // reg 0x01 data IDX=0
    /* Standby ON/OFF*/
    OLED_C_command(SEPS114A_STANDBY_ON_OFF,0x01);                               // reg 0x14 data 0x01 Standby on
    Delay_ms(5);                                                                // Wait for 5ms (1ms Delay Minimum)
    OLED_C_command(SEPS114A_STANDBY_ON_OFF,0x00);                               // Standby off   (start display oscillator)
    Delay_ms(5);                                                                // 1ms Delay Minimum (1ms Delay Minimum)
    /* Display OFF */
    OLED_C_command(SEPS114A_DISPLAY_ON_OFF,0x00);
    /* Set Oscillator operation */
    OLED_C_command(SEPS114A_ANALOG_CONTROL,0x00);                               // using external resistor and internal OSC
    /* Set frame rate */
    OLED_C_command(SEPS114A_OSC_ADJUST,0x03);                                   // frame rate : 95Hz
    /* Set active display area of panel */
    OLED_C_command(SEPS114A_DISPLAY_X1,0x00);
    OLED_C_command(SEPS114A_DISPLAY_X2,0x5F);                                   // 96 pixels wide
    OLED_C_command(SEPS114A_DISPLAY_Y1,0x00);
    OLED_C_command(SEPS114A_DISPLAY_Y2,0x5F);                                   // 96 pixels high
    /* Select the RGB data format and set the initial state of RGB interface port */
    OLED_C_command(SEPS114A_RGB_IF,0x00);                                       // RGB 8bit interface
    /* Set RGB polarity */
    OLED_C_command(SEPS114A_RGB_POL,0x00);
    /* Set display mode control */
    OLED_C_command(SEPS114A_DISPLAY_MODE_CONTROL,0x80);                         // SWAP:BGR, Reduce current : Normal, DC[1:0] : Normal
    /* Set MCU Interface */
    OLED_C_command(SEPS114A_CPU_IF,0x00);                                       // MPU External interface mode, 8bits
    /* Set Memory Read/Write mode */
    OLED_C_command(SEPS114A_MEMORY_WRITE_READ,0x00);
    /* Set row scan direction */
    OLED_C_command(SEPS114A_ROW_SCAN_DIRECTION,0x00);                           // Column : 0 --> Max, Row : 0 --> Max
    /* Set row scan mode */
    OLED_C_command(SEPS114A_ROW_SCAN_MODE,0x00);                                // Alternate scan mode
    /* Set column current */
    OLED_C_command(SEPS114A_COLUMN_CURRENT_R,0x6E);
    OLED_C_command(SEPS114A_COLUMN_CURRENT_G,0x4F);
    OLED_C_command(SEPS114A_COLUMN_CURRENT_B,0x77);
    /* Set row overlap */
    OLED_C_command(SEPS114A_ROW_OVERLAP,0x00);                                  // Band gap only
    /* Set discharge time */
    OLED_C_command(SEPS114A_DISCHARGE_TIME,0x01);                               // Discharge time : normal discharge
    /* Set peak pulse delay */
    OLED_C_command(SEPS114A_PEAK_PULSE_DELAY,0x00);
    /* Set peak pulse width */
    OLED_C_command(SEPS114A_PEAK_PULSE_WIDTH_R,0x02);
    OLED_C_command(SEPS114A_PEAK_PULSE_WIDTH_G,0x02);
    OLED_C_command(SEPS114A_PEAK_PULSE_WIDTH_B,0x02);
    /* Set precharge current */
    OLED_C_command(SEPS114A_PRECHARGE_CURRENT_R,0x14);
    OLED_C_command(SEPS114A_PRECHARGE_CURRENT_G,0x50);
    OLED_C_command(SEPS114A_PRECHARGE_CURRENT_B,0x19);
    /* Set row scan on/off  */
    OLED_C_command(SEPS114A_ROW_SCAN_ON_OFF,0x00);                              // Normal row scan
    /* Set scan off level */
    OLED_C_command(SEPS114A_SCAN_OFF_LEVEL,0x04);                               // VCC_C*0.75
    /* Set memory access point */
    OLED_C_command(SEPS114A_DISPLAYSTART_X,0x00);
    OLED_C_command(SEPS114A_DISPLAYSTART_Y,0x00);
    /* Display ON */
    OLED_C_command(SEPS114A_DISPLAY_ON_OFF,0x01);                               // reg 0x02 display on
    display_font = 10;                                                          // default OLED font - valid values are 6 7 8 10 14 18
    display_color = Color_White;                                                // default OLED text colour
    new_y = 0;                                                                  // text cursor to top of screen
    OLED_CLS();                                                                 // write black to the whole screen
}

//Sequence before writing data to memory
void DDRAM_access(){
    OLED_CS=0;
    OLED_DC=0;                                                                  // 0=command
    SPI1_Write(0x08);                                                           // instruction 0x08 select DDRAM data access port
    OLED_CS=1;
}

//Set memory area(address) to write a display data
void OLED_C_MemorySize(char X1, char X2, char Y1, char Y2){
    OLED_C_command(SEPS114A_MEM_X1,X1);
    OLED_C_command(SEPS114A_MEM_X2,X2);
    OLED_C_command(SEPS114A_MEM_Y1,Y1);
    OLED_C_command(SEPS114A_MEM_Y2,Y2);
}

//Select color
void OLED_C_Color(char colorMSB, char colorLSB ){
    OLED_C_data(colorMSB);
    OLED_C_data(colorLSB);
}

// below routine is under development and contains many bodges
// put an ascii character on screen
void OLED_C_Out(unsigned char x_co_ord, unsigned char y_co_ord, unsigned char ascii_in, uint16_t color, unsigned char OLED_font){
signed char row;                                                                // character row
unsigned char col;                                                              // character column
unsigned long font_row;                                                         // data in current row
unsigned long font_pointer;                                                     // table of addresses 1 byte ??, 2 bytes offset, 1 byte ??
unsigned long font_offset;
unsigned char ascii_off;

// see Microchip AN1182 for font coding...
// 0x00 word -  bits 13,12 orient - 11,10 bits per pixel  -  8 extended glyph - 7 to 0 font ID - rest reserved
// 0x02 word - first character
// 0x04 word - last character
// 0x06 word - height
// glyph entries follow - 4 bytes (12 bytes extended glyph) -  1 byte Glyph width - 3 bytes offset
// orient 00=normal, 01=270deg, 10=180deg, 11=90deg
// bits per pixel 00=1, 01=2 (anti alias), 1x reserved
// extended glyph 0=normal, 1=extended

    if (OLED_font == 1){
        font_nrows = guiFont_Roboto_Mono11x23_Regular[6];

        ascii_off = ascii_in & 0x7f;                                            // map high values to low ones
        if(ascii_off >= 32){                                                    // always assume character 0x20 space as first character
            ascii_off -= 32;                                                    // remap
        }
        for(row = font_nrows; row > 0; row--){
            font_pointer = (ascii_off*4)+8;                                     // skip header
            last_width = guiFont_Roboto_Mono11x23_Regular[font_pointer];               // character width
            font_offset = guiFont_Roboto_Mono11x23_Regular[font_pointer+1];            // 3 bytes offset value
            font_offset |= guiFont_Roboto_Mono11x23_Regular[font_pointer+2] << 8;
            font_offset |= (unsigned long)guiFont_Roboto_Mono11x23_Regular[font_pointer+3] << 16;
            font_offset += row;
            if(last_width > 8){                                                 // two bytes in each row
                font_offset += row;
            }
            if(last_width > 16){                                                // 3 bytes in each row
                font_offset += row;
            }
            font_row = guiFont_Roboto_Mono11x23_Regular[font_offset];                  // build up row from 1, 2 or 3 bytes
            if(last_width > 8){
                font_row |= (guiFont_Roboto_Mono11x23_Regular[font_offset+1]) << 8;
            }
            if(last_width > 16){
                font_row |= (unsigned long)(guiFont_Roboto_Mono11x23_Regular[font_offset+2]) << 16;   // force long arithmetic
            }
            for(col = 0; col <= last_width ; col++){                            // count through pixels in row
                DDRAM_access();
                if((font_row >> col)&0x01){
                    DrawPixel(x_co_ord+col,y_co_ord+row,color);                 // if bit is set, draw coloured pixel
                }
                else{
                    DrawPixel(x_co_ord+col,y_co_ord+row,Color_Black);           // if bit is clear, draw black pixel
                }
            }
        }
        if( display_x <= (95-last_width)){                                      // are we still within display?
            display_x += last_width;                                            // if so move x coordinate right
            display_x++;                                                        // inter-character gap
        }
        else{
            display_x = 95;                                                     // set right hand edge
        }
    }

    if (OLED_font == 2){
        font_nrows = guiFont_Exo_2_Condensed10x16_Regular[6];

        ascii_off = ascii_in & 0x7f;                                            // map high values to low ones
        if(ascii_off >= 32){                                                    // always assume character 0x20 space as first character
            ascii_off -= 32;                                                    // remap
        }
        for(row = font_nrows; row > 0; row--){
            font_pointer = (ascii_off*4)+8;                                     // skip header
            last_width = guiFont_Exo_2_Condensed10x16_Regular[font_pointer];               // character width
            font_offset = guiFont_Exo_2_Condensed10x16_Regular[font_pointer+1];            // 3 bytes offset value
            font_offset |= guiFont_Exo_2_Condensed10x16_Regular[font_pointer+2] << 8;
            font_offset |= (unsigned long)guiFont_Exo_2_Condensed10x16_Regular[font_pointer+3] << 16;
            font_offset += row;
            if(last_width > 8){                                                 // two bytes in each row
                font_offset += row;
            }
            if(last_width > 16){                                                // 3 bytes in each row
                font_offset += row;
            }
            font_row = guiFont_Exo_2_Condensed10x16_Regular[font_offset];                  // build up row from 1, 2 or 3 bytes
            if(last_width > 8){
                font_row |= (guiFont_Exo_2_Condensed10x16_Regular[font_offset+1]) << 8;
            }
            if(last_width > 16){
                font_row |= (unsigned long)(guiFont_Exo_2_Condensed10x16_Regular[font_offset+2]) << 16;   // force long arithmetic
            }
            for(col = 0; col <= last_width ; col++){                            // count through pixels in row
                DDRAM_access();
                if((font_row >> col)&0x01){
                    DrawPixel(x_co_ord+col,y_co_ord+row,color);                 // if bit is set, draw coloured pixel
                }
                else{
                    DrawPixel(x_co_ord+col,y_co_ord+row,Color_Black);           // if bit is clear, draw black pixel
                }
            }
        }
        if( display_x <= (95-last_width)){                                      // are we still within display?
            display_x += last_width;                                            // if so move x coordinate right
            display_x++;                                                        // inter-character gap
        }
        else{
            display_x = 95;                                                     // set right hand edge
        }
    }

    if (OLED_font == 3){
        font_nrows = guiFont_Exo_2_Condensed15x23_Regular[6];

        ascii_off = ascii_in & 0x7f;                                            // map high values to low ones
        if(ascii_off >= 32){                                                    // always assume character 0x20 space as first character
            ascii_off -= 32;                                                    // remap
        }
        for(row = font_nrows; row > 0; row--){
            font_pointer = (ascii_off*4)+8;                                     // skip header
            last_width = guiFont_Exo_2_Condensed15x23_Regular[font_pointer];               // character width
            font_offset = guiFont_Exo_2_Condensed15x23_Regular[font_pointer+1];            // 3 bytes offset value
            font_offset |= guiFont_Exo_2_Condensed15x23_Regular[font_pointer+2] << 8;
            font_offset |= (unsigned long)guiFont_Exo_2_Condensed15x23_Regular[font_pointer+3] << 16;
            font_offset += row;
            if(last_width > 8){                                                 // two bytes in each row
                font_offset += row;
            }
            if(last_width > 16){                                                // 3 bytes in each row
                font_offset += row;
            }
            font_row = guiFont_Exo_2_Condensed15x23_Regular[font_offset];                  // build up row from 1, 2 or 3 bytes
            if(last_width > 8){
                font_row |= (guiFont_Exo_2_Condensed15x23_Regular[font_offset+1]) << 8;
            }
            if(last_width > 16){
                font_row |= (unsigned long)(guiFont_Exo_2_Condensed15x23_Regular[font_offset+2]) << 16;   // force long arithmetic
            }
            for(col = 0; col <= last_width ; col++){                            // count through pixels in row
                DDRAM_access();
                if((font_row >> col)&0x01){
                    DrawPixel(x_co_ord+col,y_co_ord+row,color);                 // if bit is set, draw coloured pixel
                }
                else{
                    DrawPixel(x_co_ord+col,y_co_ord+row,Color_Black);           // if bit is clear, draw black pixel
                }
            }
        }
        if( display_x <= (95-last_width)){                                      // are we still within display?
            display_x += last_width;                                            // if so move x coordinate right
            display_x++;                                                        // inter-character gap
        }
        else{
            display_x = 95;                                                     // set right hand edge
        }
    }

    if (OLED_font == 4){
        font_nrows = guiFont_Exo_2_Condensed21x32_Regular[6];

        ascii_off = ascii_in & 0x7f;                                            // map high values to low ones
        if(ascii_off >= 32){                                                    // always assume character 0x20 space as first character
            ascii_off -= 32;                                                    // remap
        }
        for(row = font_nrows; row > 0; row--){
            font_pointer = (ascii_off*4)+8;                                     // skip header
            last_width = guiFont_Exo_2_Condensed21x32_Regular[font_pointer];               // character width
            font_offset = guiFont_Exo_2_Condensed21x32_Regular[font_pointer+1];            // 3 bytes offset value
            font_offset |= guiFont_Exo_2_Condensed21x32_Regular[font_pointer+2] << 8;
            font_offset |= (unsigned long)guiFont_Exo_2_Condensed21x32_Regular[font_pointer+3] << 16;
            font_offset += row;
            if(last_width > 8){                                                 // two bytes in each row
                font_offset += row;
            }
            if(last_width > 16){                                                // 3 bytes in each row
                font_offset += row;
            }
            font_row = guiFont_Exo_2_Condensed21x32_Regular[font_offset];                  // build up row from 1, 2 or 3 bytes
            if(last_width > 8){
                font_row |= (guiFont_Exo_2_Condensed21x32_Regular[font_offset+1]) << 8;
            }
            if(last_width > 16){
                font_row |= (unsigned long)(guiFont_Exo_2_Condensed21x32_Regular[font_offset+2]) << 16;   // force long arithmetic
            }
            for(col = 0; col <= last_width ; col++){                            // count through pixels in row
                DDRAM_access();
                if((font_row >> col)&0x01){
                    DrawPixel(x_co_ord+col,y_co_ord+row,color);                 // if bit is set, draw coloured pixel
                }
                else{
                    DrawPixel(x_co_ord+col,y_co_ord+row,Color_Black);           // if bit is clear, draw black pixel
                }
            }
        }
        if( display_x <= (95-last_width)){                                      // are we still within display?
            display_x += last_width;                                            // if so move x coordinate right
            display_x++;                                                        // inter-character gap
        }
        else{
            display_x = 95;                                                     // set right hand edge
        }
    }

/*
    if (OLED_font == 6){
        font_nrows = guiFont_Tahoma_6_Regular[6];                               // number of bytes in each entry

        ascii_off = ascii_in & 0x7f;                                            // map high values to low ones
        if(ascii_off >= 32){                                                    // always assume character 0x20 space as first character
            ascii_off -= 32;                                                    // remap
        }
        for(row = font_nrows; row > 0; row--){                                  // read pixels right to left
            font_pointer = (ascii_off*4)+8;                                     // skip 8 byte header
            last_width = guiFont_Tahoma_6_Regular[font_pointer];                // read out character width (excluding filler bytes)
            font_offset = guiFont_Tahoma_6_Regular[font_pointer+1];             // get offset low
            font_offset += guiFont_Tahoma_6_Regular[font_pointer+2]*256;        // get offset middle
            font_offset += (unsigned long)guiFont_Tahoma_6_Regular[font_pointer+3]*65536;  // get offset high and force long type calculation
            font_offset += row;                                                 // add in the row offset
            if(last_width > 8){                                                 // if width > 8 then we need 2 bytes per row
                font_offset += row;                                             // so double up byte offset
            }
            font_row = guiFont_Tahoma_6_Regular[font_offset];                   // get a row of up to 8 pixels
            if(last_width > 8){                                                 // if width > 8 then need second byte of pixels
                font_row += (guiFont_Tahoma_6_Regular[font_offset+1])*256;      // so go fetch a further byte
            }
            for(col = 0; col <= last_width ; col++){                            // count through pixels in row
                DDRAM_access();
                if((font_row >> col)&0x01){
                    DrawPixel(x_co_ord+col,y_co_ord+row,color);                 // if bit is set, draw coloured pixel
                }
                else{
                    DrawPixel(x_co_ord+col,y_co_ord+row,Color_Black);           // if bit is clear, draw black pixel
                }
            }
        }
        if( display_x <= (95-last_width)){                                      // are we still within display?
            display_x += last_width;                                            // if so move x coordinate right
            display_x++;                                                        // inter-character gap
        }
        else{
            display_x = 95;                                                     // set right hand edge
        }
    }

    if (OLED_font == 7){
        font_nrows = guiFont_Tahoma_7_Regular[6];                               // number of bytes in each entry

        ascii_off = ascii_in & 0x7f;                                            // map high values to low ones
        if(ascii_off >= 32){                                                    // always assume character 0x20 space as first character
            ascii_off -= 32;                                                    // remap
        }
        for(row = font_nrows; row > 0; row--){                                  // read pixels right to left
            font_pointer = (ascii_off*4)+8;                                     // skip 8 byte header
            last_width = guiFont_Tahoma_7_Regular[font_pointer];                // read out character width (excluding filler bytes)
            font_offset = guiFont_Tahoma_7_Regular[font_pointer+1];             // get offset low
            font_offset += guiFont_Tahoma_7_Regular[font_pointer+2]*256;        // get offset middle
            font_offset += (unsigned long)guiFont_Tahoma_7_Regular[font_pointer+3]*65536;  // get offset high and force long type calculation
            font_offset += row;                                                 // add in the row offset
            if(last_width > 8){                                                 // if width > 8 then we need 2 bytes per row
                font_offset += row;                                             // so double up byte offset
            }
            font_row = guiFont_Tahoma_7_Regular[font_offset];                   // get a row of up to 8 pixels
            if(last_width > 8){                                                 // if width > 8 then need second byte of pixels
                font_row += (guiFont_Tahoma_7_Regular[font_offset+1])*256;      // so go fetch a further byte
            }
            for(col = 0; col <= last_width ; col++){                            // count through pixels in row
                DDRAM_access();
                if((font_row >> col)&0x01){
                    DrawPixel(x_co_ord+col,y_co_ord+row,color);                 // if bit is set, draw coloured pixel
                }
                else{
                    DrawPixel(x_co_ord+col,y_co_ord+row,Color_Black);           // if bit is clear, draw black pixel
                }
            }
        }
        if( display_x <= (95-last_width)){                                      // are we still within display?
            display_x += last_width;                                            // if so move x coordinate right
            display_x++;                                                        // inter-character gap
        }
        else{
            display_x = 95;                                                     // set right hand edge
        }
    }

    if (OLED_font == 8){
        font_nrows = guiFont_Tahoma_8_Regular[6];                               // number of bytes in each entry

        ascii_off = ascii_in & 0x7f;                                            // map high values to low ones
        if(ascii_off >= 32){                                                    // always assume character 0x20 space as first character
            ascii_off -= 32;                                                    // remap
        }
        for(row = font_nrows; row > 0; row--){                                  // read pixels right to left
            font_pointer = (ascii_off*4)+8;                                     // skip 8 byte header
            last_width = guiFont_Tahoma_8_Regular[font_pointer];                // read out character width (excluding filler bytes)
            font_offset = guiFont_Tahoma_8_Regular[font_pointer+1];             // get offset low
            font_offset += guiFont_Tahoma_8_Regular[font_pointer+2]*256;        // get offset middle
            font_offset += (unsigned long)guiFont_Tahoma_8_Regular[font_pointer+3]*65536;  // get offset high and force long type calculation
            font_offset += row;                                                 // add in the row offset
            if(last_width > 8){                                                 // if width > 8 then we need 2 bytes per row
                font_offset += row;                                             // so double up byte offset
            }
            font_row = guiFont_Tahoma_8_Regular[font_offset];                   // get a row of up to 8 pixels
            if(last_width > 8){                                                 // if width > 8 then need second byte of pixels
                font_row += (guiFont_Tahoma_8_Regular[font_offset+1])*256;      // so go fetch a further byte
            }
            for(col = 0; col <= last_width ; col++){                            // count through pixels in row
                DDRAM_access();
                if((font_row >> col)&0x01){
                    DrawPixel(x_co_ord+col,y_co_ord+row,color);                 // if bit is set, draw coloured pixel
                }
                else{
                    DrawPixel(x_co_ord+col,y_co_ord+row,Color_Black);           // if bit is clear, draw black pixel
                }
            }
        }
        if( display_x <= (95-last_width)){                                      // are we still within display?
            display_x += last_width;                                            // if so move x coordinate right
            display_x++;                                                        // inter-character gap
        }
        else{
            display_x = 95;                                                     // set right hand edge
        }
    }

    if (OLED_font == 10){
        font_nrows = guiFont_Tahoma_10_Regular[6];                              // number of bytes in each entry

        ascii_off = ascii_in & 0x7f;                                            // map high values to low ones
        if(ascii_off >= 32){                                                    // always assume character 0x20 space as first character
            ascii_off -= 32;                                                    // remap
        }
        for(row = font_nrows; row > 0; row--){                                  // read pixels right to left
            font_pointer = (ascii_off*4)+8;                                     // skip 8 byte header
            last_width = guiFont_Tahoma_10_Regular[font_pointer];               // read out character width (excluding filler bytes)
            font_offset = guiFont_Tahoma_10_Regular[font_pointer+1];            // get offset low
            font_offset += guiFont_Tahoma_10_Regular[font_pointer+2]*256;       // get offset middle
            font_offset += (unsigned long)guiFont_Tahoma_10_Regular[font_pointer+3]*65536;  // get offset high and force long type calculation
            font_offset += row;                                                 // add in the row offset
            if(last_width > 8){                                                 // if width > 8 then we need 2 bytes per row
                font_offset += row;                                             // so double up byte offset
            }
            font_row = guiFont_Tahoma_10_Regular[font_offset];                  // get a row of up to 8 pixels
            if(last_width > 8){                                                 // if width > 8 then need second byte of pixels
                font_row += (guiFont_Tahoma_10_Regular[font_offset+1])*256;     // so go fetch a further byte
            }
            for(col = 0; col <= last_width ; col++){                            // count through pixels in row
                DDRAM_access();
                if((font_row >> col)&0x01){
                    DrawPixel(x_co_ord+col,y_co_ord+row,color);                 // if bit is set, draw coloured pixel
                }
                else{
                    DrawPixel(x_co_ord+col,y_co_ord+row,Color_Black);           // if bit is clear, draw black pixel
                }
            }
        }
        if( display_x <= (95-last_width)){                                      // are we still within display?
            display_x += last_width;                                            // if so move x coordinate right
            display_x++;                                                        // inter-character gap
        }
        else{
            display_x = 95;                                                     // set right hand edge
        }
    }

    if (OLED_font == 14){
        font_nrows = guiFont_Tahoma_14_Regular[6];

        ascii_off = ascii_in & 0x7f;                                            // map high values to low ones
        if(ascii_off >= 32){                                                    // always assume character 0x20 space as first character
            ascii_off -= 32;                                                    // remap
        }
        for(row = font_nrows; row > 0; row--){
            font_pointer = (ascii_off*4)+8;                                     // skip header
            last_width = guiFont_Tahoma_14_Regular[font_pointer];               // character width
            font_offset = guiFont_Tahoma_14_Regular[font_pointer+1];            // 3 bytes offset value
            font_offset |= guiFont_Tahoma_14_Regular[font_pointer+2] << 8;
            font_offset |= (unsigned long)guiFont_Tahoma_14_Regular[font_pointer+3] << 16;
            font_offset += row;
            if(last_width > 8){                                                 // two bytes in each row
                font_offset += row;
            }
            if(last_width > 16){                                                // 3 bytes in each row
                font_offset += row;
            }
            font_row = guiFont_Tahoma_14_Regular[font_offset];                  // build up row from 1, 2 or 3 bytes
            if(last_width > 8){
                font_row |= (guiFont_Tahoma_14_Regular[font_offset+1]) << 8;
            }
            if(last_width > 16){
                font_row |= (unsigned long)(guiFont_Tahoma_14_Regular[font_offset+2]) << 16;   // force long arithmetic
            }
            for(col = 0; col <= last_width ; col++){                            // count through pixels in row
                DDRAM_access();
                if((font_row >> col)&0x01){
                    DrawPixel(x_co_ord+col,y_co_ord+row,color);                 // if bit is set, draw coloured pixel
                }
                else{
                    DrawPixel(x_co_ord+col,y_co_ord+row,Color_Black);           // if bit is clear, draw black pixel
                }
            }
        }
        if( display_x <= (95-last_width)){                                      // are we still within display?
            display_x += last_width;                                            // if so move x coordinate right
            display_x++;                                                        // inter-character gap
        }
        else{
            display_x = 95;                                                     // set right hand edge
        }
    }

    if (OLED_font == 16){
        font_nrows = guiFont_Tahoma_16_Regular[6];

        ascii_off = ascii_in & 0x7f;                                            // map high values to low ones
        if(ascii_off >= 32){                                                    // always assume character 0x20 space as first character
            ascii_off -= 32;                                                    // remap
        }
        for(row = font_nrows; row > 0; row--){
            font_pointer = (ascii_off*4)+8;                                     // skip header
            last_width = guiFont_Tahoma_16_Regular[font_pointer];               // character width
            font_offset = guiFont_Tahoma_16_Regular[font_pointer+1];            // 3 bytes offset value
            font_offset |= guiFont_Tahoma_16_Regular[font_pointer+2] << 8;
            font_offset |= (unsigned long)guiFont_Tahoma_16_Regular[font_pointer+3] << 16;
            font_offset += row;
            if(last_width > 8){                                                 // two bytes in each row
                font_offset += row;
            }
            if(last_width > 16){                                                // 3 bytes in each row
                font_offset += row;
            }
            font_row = guiFont_Tahoma_16_Regular[font_offset];                  // build up row from 1, 2 or 3 bytes
            if(last_width > 8){
                font_row |= (guiFont_Tahoma_16_Regular[font_offset+1]) << 8;
            }
            if(last_width > 16){
                font_row |= (unsigned long)(guiFont_Tahoma_16_Regular[font_offset+2]) << 16;   // force long arithmetic
            }
            for(col = 0; col <= last_width ; col++){                            // count through pixels in row
                DDRAM_access();
                if((font_row >> col)&0x01){
                    DrawPixel(x_co_ord+col,y_co_ord+row,color);                 // if bit is set, draw coloured pixel
                }
                else{
                    DrawPixel(x_co_ord+col,y_co_ord+row,Color_Black);           // if bit is clear, draw black pixel
                }
            }
        }
        if( display_x <= (95-last_width)){                                      // are we still within display?
            display_x += last_width;                                            // if so move x coordinate right
            display_x++;                                                        // inter-character gap
        }
        else{
            display_x = 95;                                                     // set right hand edge
        }
    }

    if (OLED_font == 18){
        font_nrows = guiFont_Tahoma_18_Regular[6];

        ascii_off = ascii_in & 0x7f;                                            // map high values to low ones
        if(ascii_off >= 32){                                                    // always assume character 0x20 space as first character
            ascii_off -= 32;                                                    // remap
        }
        for(row = font_nrows; row > 0; row--){
            font_pointer = (ascii_off*4)+8;                                     // skip header
            last_width = guiFont_Tahoma_18_Regular[font_pointer];               // character width
            font_offset = guiFont_Tahoma_18_Regular[font_pointer+1];            // 3 bytes offset value
            font_offset |= guiFont_Tahoma_18_Regular[font_pointer+2] << 8;
            font_offset |= (unsigned long)guiFont_Tahoma_18_Regular[font_pointer+3] << 16;
            font_offset += row;
            if(last_width > 8){                                                 // two bytes in each row
                font_offset += row;
            }
            if(last_width > 16){                                                // 3 bytes in each row
                font_offset += row;
            }
            font_row = guiFont_Tahoma_18_Regular[font_offset];                  // build up row from 1, 2 or 3 bytes
            if(last_width > 8){
                font_row |= (guiFont_Tahoma_18_Regular[font_offset+1]) << 8;
            }
            if(last_width > 16){
                font_row |= (unsigned long)(guiFont_Tahoma_18_Regular[font_offset+2]) << 16;   // force long arithmetic
            }
            for(col = 0; col <= last_width ; col++){                            // count through pixels in row
                DDRAM_access();
                if((font_row >> col)&0x01){
                    DrawPixel(x_co_ord+col,y_co_ord+row,color);                 // if bit is set, draw coloured pixel
                }
                else{
                    DrawPixel(x_co_ord+col,y_co_ord+row,Color_Black);           // if bit is clear, draw black pixel
                }
            }
        }
        if( display_x <= (95-last_width)){                                      // are we still within display?
            display_x += last_width;                                            // if so move x coordinate right
            display_x++;                                                        // inter-character gap
        }
        else{
            display_x = 95;                                                     // set right hand edge
        }
    }

*/
}

// Set a single pixel - requires left/right swap to convert 0,0 from top left logical to top right display requirement
void drawPixel(char px, char py, uint16_t color){
char swapped_x;

    if(px <96){                                                                 // check on screen
        swapped_x = 95 - px;                                                    // move x coordinate left/right
    }
    else{
        swapped_x = 95;                                                         // left side of screen
    }
    OLED_C_MemorySize( swapped_x,  swapped_x,  py,  py);                        // set display position
    DDRAM_access();                                                             // select data memory on display
    OLED_C_Color(color >> 8,color & 0xff);                                      // white
}